package org.xdoclet.plugin.xwork.qtags;

import org.generama.MetadataProvider;

public class TagLibrary {
    public static final String XWORK_ACTION = XworkActionTagImpl.NAME;
    public static final String XWORK_EXCEPTION_MAPPING = XworkExceptionMappingTagImpl.NAME;
    public static final String XWORK_INTERCEPTOR_REF = XworkInterceptorRefTagImpl.NAME;
    public static final String XWORK_PARAM = XworkParamTagImpl.NAME;
    public static final String XWORK_RESULT = XworkResultTagImpl.NAME;

    public TagLibrary(MetadataProvider metadataProvider) {
        metadataProvider.getDocletTagFactory().registerTag(XworkActionTagImpl.NAME, XworkActionTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(XworkExceptionMappingTagImpl.NAME, XworkExceptionMappingTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(XworkInterceptorRefTagImpl.NAME, XworkInterceptorRefTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(XworkParamTagImpl.NAME, XworkParamTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(XworkResultTagImpl.NAME, XworkResultTagImpl.class);
    }
}
